"use client";

import { useState } from "react";
import Image from "next/image";
import { useSession } from "next-auth/react";
import { useQuery, useMutation, useQueryClient } from "@tanstack/react-query";
import { ColumnDef } from "@tanstack/react-table";
import axios from "axios";
import { DropdownMenu } from "radix-ui";
import FloatingLabelInput from "#/components/floatingLabelInput";
import { Modal } from "#/components/modal";
import Table from "#/components/table/table";
import Form from "#/components/form/form";
import { icons } from "#/assets/icons";
import { adminSchema } from "#/schema";
import { Admin } from "#/types";

export default function Admins() {
  const { data: session, status } = useSession();
  const [openModal, setOpenModal] = useState(false);
  const [openDeleteModal, setOpenDeleteModal] = useState(false);
  const [openEditModal, setOpenEditModal] = useState(false);
  const [selectedAdminId, setSelectedAdminId] = useState<string | null>(null);

  const queryClient = useQueryClient();
  
  const {
    data: users,
    refetch,
    isLoading,
  } = useQuery({
    enabled: status === "authenticated",
    queryKey: ["users"],
    queryFn: async () => {
      try {
        const response = await axios.get(
          "https://private-docs-api.intside.co/users",
          {
            headers: { Authorization: `Bearer ${session?.user.access_token}` },
          }
        );
        return response.data.data as Admin[];
      } catch (error) {
        console.error(error);
        return [];
      }
    },
  });

  
  const createMutation = useMutation({
    mutationFn: async (data: {
      last_name: string;
      first_name: string;
      email: string;
    }) => {
      try {
        const response = await axios.post(
          "https://private-docs-api.intside.co/users/",
          { ...data, user_type: "admin" },
          { headers: { Authorization: `Bearer ${session?.user.access_token}` } }
        );

        if (response.status === 200 || response.status === 201) {
          console.log("ajout réussie !");
          setOpenModal(false);
        }
      } catch (error) {
        console.error("Erreur lors de la création", error);
      }
    },
    onSuccess: () => {
      queryClient.invalidateQueries({ queryKey: ["users"] });
      refetch();
    },
  });

  const updateMutation = useMutation({
    mutationFn: async (data: {
      id: string;
      last_name: string;
      first_name: string;
      email: string;
    }) => {
      try {
        const response = await axios.put(
          `https://private-docs-api.intside.co/users/${data.id}/`,
          data,
          { headers: { Authorization: `Bearer ${session?.user.access_token}` } }
        );

        if (response.status === 200 || response.status === 201) {
          console.log("modification réussie !");
          setOpenEditModal(false);
        }
      } catch (error) {
        console.error("Erreur lors de la mise à jour", error);
      }
    },
    onSuccess: () => {
      queryClient.invalidateQueries({ queryKey: ["users"] });
      refetch();
    },
  });

  const deleteMutation = useMutation({
    mutationFn: async (id: string) => {
      try {
        const response = await axios.delete(
          `https://private-docs-api.intside.co/users/${id}/`,
          {
            headers: { Authorization: `Bearer ${session?.user.access_token}` },
          }
        );

        if (response.status === 200 || response.status === 201) {
          console.log("Suppresion réussie !");
          setOpenDeleteModal(false);
        }
      } catch (error) {
        console.error("Erreur lors de la suppression", error);
      }
    },
    onSuccess: () => {
      queryClient.invalidateQueries({ queryKey: ["users"] });
      refetch();
    },
  });

  const bulkDeleteMutation = useMutation({
    mutationFn: async (ids: string[]) => {
      try {
        const deletePromises = ids.map((id) =>
          axios.delete(`https://private-docs-api.intside.co/users/${id}/`, {
            headers: { Authorization: `Bearer ${session?.user.access_token}` },
          })
        );
        await Promise.all(deletePromises);
      } catch (error) {
        console.error("Erreur lors de la suppression groupée", error);
      }
    },
    onSuccess: () => {
      queryClient.invalidateQueries({ queryKey: ["users"] });
      refetch();
    },
  });

  const columns: ColumnDef<Admin>[] = [
    {
      header: "Administrateurs",
      cell: ({ row }) => {
        const fullName = `${row.original.first_name} ${row.original.last_name}`;
        const initials = `${row.original.first_name[0]}${row.original.last_name[0]}`;
        return (
          <div className="flex space-x-2 items-center">
            <div className="flex items-center justify-center bg-[#DCDCFE] text-[#246BFD] w-10 h-10 rounded-full">
              {initials}
            </div>
            <p>{fullName}</p>
          </div>
        );
      },
    },
    {
      accessorKey: "email",
      header: "Adresse e-mail",
    },
    {
      id: "actions",
      cell: ({ row }) => {
        const admin = row.original;
        return (
          <div className="flex justify-end p-2 space-x-2">
            {/* Modal d'édition */}
            <Modal
              open={openEditModal && selectedAdminId === admin.id}
              onOpenChange={(isOpen) => {
                if (!isOpen) {
                  setSelectedAdminId(null);
                  setOpenEditModal(false);
                }
              }}
              trigger={
                <div
                  onClick={() => {
                    setSelectedAdminId(admin.id);
                    setOpenEditModal(true);
                  }}
                >
                  <Image
                    alt="Éditer"
                    width={24}
                    height={24}
                    src={icons.editIcon}
                    className="cursor-pointer responsive-icon mr-1"
                  />
                </div>
              }
              title="Modifier un admin"
              content={
                <Form
                  fields={[
                    { name: "id", type: "hidden", defaultValue: admin.id },
                    {
                      name: "last_name",
                      label: "Nom",
                      type: "text",
                      placeholder: "Entrer le nom de l'admin",
                      defaultValue: admin.last_name,
                    },
                    {
                      name: "first_name",
                      label: "Prénom",
                      type: "text",
                      placeholder: "Entrer le prénom de l'admin",
                      defaultValue: admin.first_name,
                    },
                    {
                      name: "email",
                      label: "Adresse e-mail",
                      type: "text",
                      placeholder: "Entrer l'email de l'admin",
                      defaultValue: admin.email,
                    },
                  ]}
                  submit={updateMutation.mutate}
                  schema={adminSchema}
                  child={
                      <div className="flex justify-center">
                      <button
                      type="submit"
                      disabled={updateMutation.isPending}
                      className={`${updateMutation.isPending ? "btn-auth-loading" : "btn-auth"} cta modal-cta mt-4 cursor-pointer`}
                    >
                      {updateMutation.isPending ? "En cours..." : "Modifier"}
                    </button>
                    </div>
                  }
                />
              }
            />

            {/* Modal de suppression */}
            <Modal
              open={openDeleteModal && selectedAdminId === admin.id}
              onOpenChange={(isOpen) => {
                if (!isOpen) {
                  setSelectedAdminId(null);
                  setOpenDeleteModal(false);
                }
              }}
              trigger={
                <div
                  onClick={() => {
                    setSelectedAdminId(admin.id);
                    setOpenDeleteModal(true);
                  }}
                >
                  <Image
                    alt="Supprimer"
                    src={icons.trash}
                    className="cursor-pointer responsive-icon"
                  />
                </div>
              }
              title="Supprimer un admin"
              content={
                <div>
                  <p className="text-center">Voulez-vous vraiment supprimer cet admin ?</p>
                  <div className="grid grid-cols-2 gap-3 mt-3">
                    <button
                      className="bg-blue-100 text-blue-600 py-2 px-4 rounded-full cursor-pointer"
                      onClick={() => {
                        setOpenDeleteModal(false);
                      }}
                    >
                      Annuler
                    </button>
                    <button
                      className="bg-red-500 text-white py-2 px-4 rounded-full hover:bg-red-600 cursor-pointer"
                      onClick={() => {
                        deleteMutation.mutate(admin.id);
                      }}
                    >
                      Supprimer
                    </button>
                  </div>
                </div>
              }
            />
          </div>
        );
      },
    },
  ];

  return (
    <Table
      columns={columns}
      data={users || []}
      pageSize={5}
      isDataLoading={isLoading}
      header={(table) => {
        const selectedIds = table
          .getRowModel()
          .rows.filter((row) => row.getIsSelected())
          .map((row) => row.original.id);

        return (
          <div className="grid grid-cols-1 lg:grid-cols-2 w-full space-y-3">
            <div className="flex items-center space-x-3">
              <input
                type="checkbox"
                checked={
                  table.getIsAllPageRowsSelected() ||
                  (table.getIsSomePageRowsSelected() && undefined)
                }
                onChange={(e) =>
                  table.toggleAllPageRowsSelected(e.target.checked)
                }
              />

              <DropdownMenu.Root>
                <DropdownMenu.Trigger asChild>
                  <p className="cta cancel flex gap-2">
                    Sélectionner une action
                    <Image src={icons.arrowDown} alt="arrow down" />
                  </p>
                </DropdownMenu.Trigger>

                <DropdownMenu.Portal>
                  <DropdownMenu.Content
                    className="min-w-[150px] shadow-sm bg-white rounded-md p-1"
                    sideOffset={5}
                  >
                    <DropdownMenu.Item
                      onClick={() => bulkDeleteMutation.mutate(selectedIds)}
                      className="p-2 text-[14px] cursor-pointer hover:bg-blue-100 hover:text-blue-500 rounded-md"
                    >
                      Supprimer
                    </DropdownMenu.Item>
                  </DropdownMenu.Content>
                </DropdownMenu.Portal>
              </DropdownMenu.Root>
            </div>

            <div className="flex justify-between lg:justify-end space-x-3">
              {/* Modal d'ajout */}
              <Modal
                title="Ajouter un admin"
                open={openModal}
                onOpenChange={(isOpen) => {
                  if (!isOpen) {
                    setOpenModal(false);
                  }
                }}
                trigger={
                  <div
                    onClick={() => setOpenModal(true)}
                    className="cta"
                  >
                    Ajouter un admin
                  </div>
                }
                content={
                  <Form
                    fields={[
                      {
                        name: "last_name",
                        label: "Nom",
                        type: "text",
                        placeholder: "Entrer le nom de l'admin",
                      },
                      {
                        name: "first_name",
                        label: "Prénom",
                        type: "text",
                        placeholder: "Entrer le prénom de l'admin",
                      },
                      {
                        name: "email",
                        label: "Adresse e-mail",
                        type: "text",
                        placeholder: "Entrer l'email de l'admin",
                      },
                    ]}
                    submit={createMutation.mutate}
                    schema={adminSchema}
                    child={
                      <div className="flex justify-center">
                      <button
                        type="submit"
                        disabled={createMutation.isPending}
                        className={`${createMutation.isPending ? "btn-auth-loading" : "btn-auth"} cta modal-cta mt-4 cursor-pointer`}
                      >
                        {createMutation.isPending ? "Création de l'admin..." : "Créer le compte"}
                      </button>
                      </div>
                    }
                  />
                }
              />

              <FloatingLabelInput
                name="search"
                placeholder="Effectuer une recherche"
                type="search"
                onChange={(value) => table.setGlobalFilter(value)}
                button={
                  <Image
                    alt="Filtrer"
                    src={icons.filterIcon}
                    className="cursor-pointer"
                  />
                }
              />
            </div>
          </div>
        );
      }}
    />
  );
}
